//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vJAXB 2.1.10 in JDK 6 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.06.07 at 02:55:28 PM CEST 
//


package net.ihe.gazelle.cdagen.constraint.model;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.jboss.seam.annotations.Name;


/**
 * <p>Java class for classe complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="classe"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="name" type="{http://www.w3.org/2001/XMLSchema}string"/&gt;
 *         &lt;element name="class_type" type="{http://www.w3.org/2001/XMLSchema}string"/&gt;
 *         &lt;element name="element_name" type="{http://www.w3.org/2001/XMLSchema}string"/&gt;
 *         &lt;element name="templateId" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/&gt;
 *         &lt;sequence maxOccurs="unbounded" minOccurs="0"&gt;
 *           &lt;element name="constraint" type="{}constraint"/&gt;
 *         &lt;/sequence&gt;
 *       &lt;/sequence&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */

@Entity
@Name("classe")
@Table(name="cons_classe", schema="public", uniqueConstraints = @UniqueConstraint(columnNames = "id"))
@SequenceGenerator(name = "cons_classe_sequence", sequenceName = "cons_classe_id_seq", allocationSize=1)

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "classe", propOrder = {
    "id",
    "name",
    "classType",
    "xmlName",
    "templateId",
    "parentId",
    "constraints",
    "properties",
    "operations"
})
public class Classe implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@NotNull
	@Column(name="id", nullable = false, unique = true)
	@GeneratedValue(strategy=GenerationType.SEQUENCE, generator="cons_classe_sequence")
	protected Integer id;

    @XmlElement(required = true)
    protected String name;
    
    @XmlElement(name = "class_type", required = true)
    protected String classType;
    
    @XmlElement(name = "xmlName", required = true)
    protected String xmlName;
    
    protected String templateId;
    
    protected String parentId;
    
    @ManyToOne
    @JoinColumn(name="parent_id")
    @XmlTransient
    protected Classe parent;
    
    @OneToMany(mappedBy = "classe", fetch = FetchType.LAZY)
    protected List<Constraint> constraints;
    
    @OneToMany(mappedBy = "classe", fetch = FetchType.LAZY)
    @XmlElement(name = "property")
    protected List<Property> properties;
    
    @OneToMany(mappedBy = "classe", fetch = FetchType.LAZY)
    @XmlElement(name = "operation")
    protected List<Operation> operations;
    
    @OneToMany(mappedBy = "parent", fetch = FetchType.LAZY)
    @XmlTransient
    protected List<Classe> childs;
    
    @ManyToOne
    @JoinColumn(name = "package_id")
    @XmlTransient
    protected Packag _package;

    public Packag get_package() {
		return _package;
	}

	public void set_package(Packag _package) {
		this._package = _package;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Integer getId() {
		return id;
	}

	public String getName() {
        return name;
    }

    public void setName(String value) {
        this.name = value;
    }

    public String getClassType() {
        return classType;
    }

    public void setClassType(String value) {
        this.classType = value;
    }

    public String getXmlName() {
        return xmlName;
    }

    public void setXmlName(String value) {
        this.xmlName = value;
    }

    public String getTemplateId() {
        return templateId;
    }

    public void setTemplateId(String value) {
        this.templateId = value;
    }
    
    public String getParentId() {
		return parentId;
	}

	public void setParentId(String parentId) {
		this.parentId = parentId;
	}

	public Classe getParent() {
		return parent;
	}

	public void setParent(Classe parent) {
		this.parent = parent;
	}

	public List<Constraint> getConstraints() {
		return constraints;
	}

	public void setConstraints(List<Constraint> constraints) {
		this.constraints = constraints;
	}

	public List<Property> getProperties() {
		return properties;
	}

	public void setProperties(List<Property> properties) {
		this.properties = properties;
	}

	public List<Operation> getOperations() {
		return operations;
	}

	public void setOperations(List<Operation> operations) {
		this.operations = operations;
	}

	public List<Classe> getChilds() {
		return childs;
	}

	public void setChilds(List<Classe> childs) {
		this.childs = childs;
	}

	public static void deleteClasse(EntityManager em, Classe cl){
    	if ((cl!= null) && (cl.getId() != null)){
    		if (cl.getConstraints() != null){
    			for (Constraint cons : cl.getConstraints()) {
    				Constraint.deleteConstraint(em, cons);
				}
    		}
    		cl.set_package(null);
    		cl.setConstraints(null);
    		em.remove(cl);
    		em.flush();
    	}
    }
    

}
